"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useErrorBoundary = exports.withErrorBoundary = exports.ErrorBoundaryContext = void 0;
const react_1 = __importStar(require("react"));
class ErrorBoundary extends react_1.Component {
    constructor() {
        super(...arguments);
        this.displayName = "ReactUseErrorBoundary";
    }
    componentDidCatch(...args) {
        this.setState({});
        this.props.onError(...args);
    }
    render() {
        return this.props.children;
    }
}
const noop = () => false;
const errorBoundaryContext = react_1.createContext({
    componentDidCatch: { current: undefined },
    error: false,
    setError: noop,
});
const ErrorBoundaryContext = ({ children }) => {
    const [error, setError] = react_1.useState(false);
    const componentDidCatch = react_1.useRef();
    const ctx = react_1.useMemo(() => ({
        componentDidCatch,
        error,
        setError,
    }), [error]);
    return (react_1.default.createElement(errorBoundaryContext.Provider, { value: ctx },
        react_1.default.createElement(ErrorBoundary, { error: error, onError: (...args) => {
                var _a;
                setError(true);
                (_a = componentDidCatch.current) === null || _a === void 0 ? void 0 : _a.call(componentDidCatch, ...args);
            } }, children)));
};
exports.ErrorBoundaryContext = ErrorBoundaryContext;
exports.ErrorBoundaryContext.displayName = "ReactUseErrorBoundaryContext";
function withErrorBoundary(WrappedComponent) {
    return (props) => (react_1.default.createElement(exports.ErrorBoundaryContext, null,
        react_1.default.createElement(WrappedComponent, Object.assign({ key: "WrappedComponent" }, props))));
}
exports.withErrorBoundary = withErrorBoundary;
function useErrorBoundary(componentDidCatch) {
    const ctx = react_1.useContext(errorBoundaryContext);
    ctx.componentDidCatch.current = componentDidCatch;
    const resetError = react_1.useCallback(() => {
        ctx.setError(false);
    }, []);
    return [ctx.error, resetError];
}
exports.useErrorBoundary = useErrorBoundary;
